com.amazonaws.services.machinelearning.model

## Class S3DataSpec

- java.lang.Object
- - com.amazonaws.services.machinelearning.model.S3DataSpec

All Implemented Interfaces:
  Serializable, Cloneable

    public class S3DataSpec
    extends Object
    implements Serializable, Cloneable

Describes the data specification of a `DataSource`.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`S3DataSpec()`

### Method Summary

All Methods Instance Methods Concrete Methods
`S3DataSpec` `clone()`
`boolean` `equals(Object obj)`
`String` `getDataLocationS3()` The location of the data file(s) used by a `DataSource`.
`String` `getDataRearrangement()` A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`.
`String` `getDataSchema()` A JSON string that represents the schema for an Amazon S3 `DataSource`.
`String` `getDataSchemaLocationS3()` Describes the schema location in Amazon S3.
`int` `hashCode()`
`void` `setDataLocationS3(String dataLocationS3)` The location of the data file(s) used by a `DataSource`.
`void` `setDataRearrangement(String dataRearrangement)` A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`.
`void` `setDataSchema(String dataSchema)` A JSON string that represents the schema for an Amazon S3 `DataSource`.
`void` `setDataSchemaLocationS3(String dataSchemaLocationS3)` Describes the schema location in Amazon S3.
`String` `toString()` Returns a string representation of this object; useful for testing and debugging.
`S3DataSpec` `withDataLocationS3(String dataLocationS3)` The location of the data file(s) used by a `DataSource`.
`S3DataSpec` `withDataRearrangement(String dataRearrangement)` A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`.
`S3DataSpec` `withDataSchema(String dataSchema)` A JSON string that represents the schema for an Amazon S3 `DataSource`.
`S3DataSpec` `withDataSchemaLocationS3(String dataSchemaLocationS3)` Describes the schema location in Amazon S3.

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### S3DataSpec

    public S3DataSpec()

### Method Detail

#### setDataLocationS3

    public void setDataLocationS3(String dataLocationS3)

The location of the data file(s) used by a `DataSource`. The URI specifies a data file or an Amazon Simple Storage Service (Amazon S3) directory or bucket containing data files.

Parameters:
  `dataLocationS3` - The location of the data file(s) used by a `DataSource`. The URI specifies a data file or an Amazon Simple Storage Service (Amazon S3) directory or bucket containing data files.

#### getDataLocationS3

    public String getDataLocationS3()

The location of the data file(s) used by a `DataSource`. The URI specifies a data file or an Amazon Simple Storage Service (Amazon S3) directory or bucket containing data files.

Returns:
  The location of the data file(s) used by a `DataSource`. The URI specifies a data file or an Amazon Simple Storage Service (Amazon S3) directory or bucket containing data files.

#### withDataLocationS3

    public S3DataSpec withDataLocationS3(String dataLocationS3)

The location of the data file(s) used by a `DataSource`. The URI specifies a data file or an Amazon Simple Storage Service (Amazon S3) directory or bucket containing data files.

Parameters:
  `dataLocationS3` - The location of the data file(s) used by a `DataSource`. The URI specifies a data file or an Amazon Simple Storage Service (Amazon S3) directory or bucket containing data files.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setDataRearrangement

    public void setDataRearrangement(String dataRearrangement)

A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

There are multiple parameters that control what data is used to create a datasource:

- `percentBegin`

  Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `percentEnd`

  Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `complement`

  The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

  For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

  Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

  Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

- `strategy`

  To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

  The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

  The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

  To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

  The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

Parameters:
  `dataRearrangement` - A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

  There are multiple parameters that control what data is used to create a datasource:

  - `percentBegin`

    Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `percentEnd`

    Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `complement`

    The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

    For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

    Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

    Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

  - `strategy`

    To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

    The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

    The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

    To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

    The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

#### getDataRearrangement

    public String getDataRearrangement()

A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

There are multiple parameters that control what data is used to create a datasource:

- `percentBegin`

  Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `percentEnd`

  Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `complement`

  The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

  For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

  Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

  Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

- `strategy`

  To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

  The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

  The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

  To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

  The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

Returns:
  A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

  There are multiple parameters that control what data is used to create a datasource:

  - `percentBegin`

    Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `percentEnd`

    Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `complement`

    The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

    For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

    Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

    Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

  - `strategy`

    To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

    The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

    The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

    To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

    The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

#### withDataRearrangement

    public S3DataSpec withDataRearrangement(String dataRearrangement)

A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

There are multiple parameters that control what data is used to create a datasource:

- `percentBegin`

  Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `percentEnd`

  Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

- `complement`

  The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

  For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

  Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

  Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

- `strategy`

  To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

  The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

  The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

  To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

  The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

  Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

  Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

Parameters:
  `dataRearrangement` - A JSON string that represents the splitting and rearrangement processing to be applied to a `DataSource`. If the `DataRearrangement` parameter is not provided, all of the input data is used to create the `Datasource`.

  There are multiple parameters that control what data is used to create a datasource:

  - `percentBegin`

    Use `percentBegin` to indicate the beginning of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `percentEnd`

    Use `percentEnd` to indicate the end of the range of the data used to create the Datasource. If you do not include `percentBegin` and `percentEnd`, Amazon ML includes all of the data when creating the datasource.

  - `complement`

    The `complement` parameter instructs Amazon ML to use the data that is not included in the range of `percentBegin` to `percentEnd` to create a datasource. The `complement` parameter is useful if you need to create complementary datasources for training and evaluation. To create a complementary datasource, use the same values for `percentBegin` and `percentEnd`, along with the `complement` parameter.

    For example, the following two datasources do not share any data, and can be used to train and evaluate a model. The first datasource has 25 percent of the data, and the second one has 75 percent of the data.

    Datasource for evaluation: `{"splitting":{"percentBegin":0, "percentEnd":25}}`

    Datasource for training: `{"splitting":{"percentBegin":0, "percentEnd":25, "complement":"true"}}`

  - `strategy`

    To change how Amazon ML splits the data for a datasource, use the `strategy` parameter.

    The default value for the `strategy` parameter is `sequential`, meaning that Amazon ML takes all of the data records between the `percentBegin` and `percentEnd` parameters for the datasource, in the order that the records appear in the input data.

    The following two `DataRearrangement` lines are examples of sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"sequential", "complement":"true"}}`

    To randomly split the input data into the proportions indicated by the percentBegin and percentEnd parameters, set the `strategy` parameter to `random` and provide a string that is used as the seed value for the random data splitting (for example, you can use the S3 path to your data as the random seed string). If you choose the random split strategy, Amazon ML assigns each row of data a pseudo-random number between 0 and 100, and then selects the rows that have an assigned number between `percentBegin` and `percentEnd`. Pseudo-random numbers are assigned using both the input seed string value and the byte offset as a seed, so changing the data results in a different split. Any existing ordering is preserved. The random splitting strategy ensures that variables in the training and evaluation data are distributed similarly. It is useful in the cases where the input data may have an implicit sort order, which would otherwise result in training and evaluation datasources containing non-similar data records.

    The following two `DataRearrangement` lines are examples of non-sequentially ordered training and evaluation datasources:

    Datasource for evaluation: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv"}}`

    Datasource for training: `{"splitting":{"percentBegin":70, "percentEnd":100, "strategy":"random", "randomSeed"="s3://my_s3_path/bucket/file.csv", "complement":"true"}}`

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setDataSchema

    public void setDataSchema(String dataSchema)

A JSON string that represents the schema for an Amazon S3 `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

You must provide either the `DataSchema` or the `DataSchemaLocationS3`.

Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

{ "version": "1.0",

"recordAnnotationFieldName": "F1",

"recordWeightFieldName": "F2",

"targetFieldName": "F3",

"dataFormat": "CSV",

"dataFileContainsHeader": true,

"attributes": [

{ "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

"excludedVariableNames": [ "F6" ] }

Parameters:
  `dataSchema` - A JSON string that represents the schema for an Amazon S3 `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

  You must provide either the `DataSchema` or the `DataSchemaLocationS3`.

  Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

  { "version": "1.0",

  "recordAnnotationFieldName": "F1",

  "recordWeightFieldName": "F2",

  "targetFieldName": "F3",

  "dataFormat": "CSV",

  "dataFileContainsHeader": true,

  "attributes": [

  { "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

  "excludedVariableNames": [ "F6" ] }

#### getDataSchema

    public String getDataSchema()

A JSON string that represents the schema for an Amazon S3 `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

You must provide either the `DataSchema` or the `DataSchemaLocationS3`.

Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

{ "version": "1.0",

"recordAnnotationFieldName": "F1",

"recordWeightFieldName": "F2",

"targetFieldName": "F3",

"dataFormat": "CSV",

"dataFileContainsHeader": true,

"attributes": [

{ "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

"excludedVariableNames": [ "F6" ] }

Returns:
  A JSON string that represents the schema for an Amazon S3 `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

  You must provide either the `DataSchema` or the `DataSchemaLocationS3`.

  Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

  { "version": "1.0",

  "recordAnnotationFieldName": "F1",

  "recordWeightFieldName": "F2",

  "targetFieldName": "F3",

  "dataFormat": "CSV",

  "dataFileContainsHeader": true,

  "attributes": [

  { "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

  "excludedVariableNames": [ "F6" ] }

#### withDataSchema

    public S3DataSpec withDataSchema(String dataSchema)

A JSON string that represents the schema for an Amazon S3 `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

You must provide either the `DataSchema` or the `DataSchemaLocationS3`.

Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

{ "version": "1.0",

"recordAnnotationFieldName": "F1",

"recordWeightFieldName": "F2",

"targetFieldName": "F3",

"dataFormat": "CSV",

"dataFileContainsHeader": true,

"attributes": [

{ "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

"excludedVariableNames": [ "F6" ] }

Parameters:
  `dataSchema` - A JSON string that represents the schema for an Amazon S3 `DataSource`. The `DataSchema` defines the structure of the observation data in the data file(s) referenced in the `DataSource`.

  You must provide either the `DataSchema` or the `DataSchemaLocationS3`.

  Define your `DataSchema` as a series of key-value pairs. `attributes` and `excludedVariableNames` have an array of key-value pairs for their value. Use the following format to define your `DataSchema`.

  { "version": "1.0",

  "recordAnnotationFieldName": "F1",

  "recordWeightFieldName": "F2",

  "targetFieldName": "F3",

  "dataFormat": "CSV",

  "dataFileContainsHeader": true,

  "attributes": [

  { "fieldName": "F1", "fieldType": "TEXT" }, { "fieldName": "F2", "fieldType": "NUMERIC" }, { "fieldName": "F3", "fieldType": "CATEGORICAL" }, { "fieldName": "F4", "fieldType": "NUMERIC" }, { "fieldName": "F5", "fieldType": "CATEGORICAL" }, { "fieldName": "F6", "fieldType": "TEXT" }, { "fieldName": "F7", "fieldType": "WEIGHTED_INT_SEQUENCE" }, { "fieldName": "F8", "fieldType": "WEIGHTED_STRING_SEQUENCE" } ],

  "excludedVariableNames": [ "F6" ] }

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setDataSchemaLocationS3

    public void setDataSchemaLocationS3(String dataSchemaLocationS3)

Describes the schema location in Amazon S3. You must provide either the `DataSchema` or the `DataSchemaLocationS3`.

Parameters:
  `dataSchemaLocationS3` - Describes the schema location in Amazon S3. You must provide either the `DataSchema` or the `DataSchemaLocationS3`.

#### getDataSchemaLocationS3

    public String getDataSchemaLocationS3()

Describes the schema location in Amazon S3. You must provide either the `DataSchema` or the `DataSchemaLocationS3`.

Returns:
  Describes the schema location in Amazon S3. You must provide either the `DataSchema` or the `DataSchemaLocationS3`.

#### withDataSchemaLocationS3

    public S3DataSpec withDataSchemaLocationS3(String dataSchemaLocationS3)

Describes the schema location in Amazon S3. You must provide either the `DataSchema` or the `DataSchemaLocationS3`.

Parameters:
  `dataSchemaLocationS3` - Describes the schema location in Amazon S3. You must provide either the `DataSchema` or the `DataSchemaLocationS3`.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### toString

    public String toString()

Returns a string representation of this object; useful for testing and debugging.

Overrides:
  `toString` in class `Object`
Returns:
  A string representation of this object.
See Also:
  `Object.toString()`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### clone

    public S3DataSpec clone()

Overrides:
  `clone` in class `Object`